/*------------------------------------------------------------------+
 |                                            Trinity-Impulse.mq4   |
 |                                           basisforex@gmail.com   |
 +------------------------------------------------------------------*/ 
#property copyright "Copyright  2010, basisforex@gmail.com"
//----
#property indicator_separate_window
//----
#property indicator_buffers 1
#property indicator_color1 Blue
//----
extern int    nPeriod             = 5;
extern int    nLevel              = 34;
extern bool   alertsOn            = true;
extern bool   alertsOnCurrent     = false;
extern bool   alertsOnFirst0Break = true;
extern bool   alertsMessage       = true;
extern bool   alertsSound         = false;
extern bool   alertsNotify        = true;
extern bool   alertsEmail         = true;
extern string soundFile           = "alert2.wav"; 
//----
double c[];
double f[];
double iCF[];
double trend[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0, iCF); SetIndexLabel(0, "Trinity-Impulse("+nPeriod+")");  SetIndexDrawBegin(0, nPeriod);
   SetIndexBuffer(1, c);
   SetIndexBuffer(2, f);
   SetIndexBuffer(3, trend);
      IndicatorShortName("Trinity-Impulse("+nPeriod+")");
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
 {
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

      for(int j = limit; j >= 0; j--)
      {
         c[j]      = iCCI(NULL, 0, nPeriod, PRICE_WEIGHTED, j);     
         f[j]     = iForce(NULL, 0, nPeriod, MODE_LWMA, PRICE_WEIGHTED, j);
         iCF[j]   = 0;
         if (alertsOnFirst0Break)
               trend[j] = trend[j+1];
         else  trend[j] = 0;
         if(c[j] * f[j] >= nLevel)
         {
            if(c[j] > 0 &&  f[j] > 0) { iCF[j] =  1; trend[j] =  1; }
            if(c[j] < 0 &&  f[j] < 0) { iCF[j] = -1; trend[j] = -1; }
         }           
      }
      manageAlerts();
      return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"up");
         if (trend[whichBar] ==-1) doAlert(whichBar,"down");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" - trinity impulse signal "+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," trinity impulse "),message);
          if (alertsSound)   PlaySound(soundFile);
   }
}